#ifndef ARITHC_H
#define ARITHC_H

#include "inc.h"

/*
 * Notez:
 *
 *  "totrange" must be <= arith->FastArithCumProbMax at all times !!
 *
 */

typedef struct {
    int probMax;
    int probMaxSafe;

    /* PRIVATE: */
    ubyte* outBuf;
    ubyte* outPtr;

    ulong code;
    ulong range;

    /* Encoder only: */
    ulong overflow_bytes;
    ulong queue;
} Arith;

extern Arith*arith_init( void );
extern void  arith_destroy( Arith* arith );

extern void  arith_encodeInitNoStuff( Arith* arith, ubyte* outBuf ); /* DANGER! Writes to buf[-1] !! */
extern void  arith_encodeInit(        Arith* arith, ubyte* outBuf );
extern void  arith_encode(            Arith* arith, ulong symlow, ulong symhigh, ulong symtot );
extern int   arith_encodeDone(        Arith* arith );

extern void  arith_decodeInitNoStuff( Arith* arith, ubyte* outBuf );
extern void  arith_decodeInit(        Arith* arith, ubyte* outBuf );
extern ulong arith_get(               Arith* arith, ulong tot );
extern void  arith_decode(            Arith* arith, ulong low, ulong high, ulong totrange );
extern void  arith_decodeDone(        Arith* arith );

extern void  arith_encodeReInit(      Arith* arith, ubyte* outBuf );	/* For resuming after a flush. */
extern void  arith_decodeReInit(      Arith* arith, ubyte* outBuf );	/* For resuming after a flush. */

extern void  arith_encBit(            Arith* arith, ulong p0, ulong pt, bool bit );
extern bool  arith_decBit(            Arith* arith, ulong p0, ulong pt );

#endif /* ARITHC_H */
