#include "codecntx.h"

// if a symbol of count < Novel is excluded, should we subtract from the escape?
//	I think not, since DONT_SEE_EXCLUDED failed

//#define DO_USE_LOE_SEESTATE  // hurts alot ;
								// it should, since LOE does the penalize NonDet
								//	which should be an loe-only thing, not a coding thing
/* */
bool codeContext_encodeFromContext( Arith* arith, Context* cntx, Exclude* exc,See* see, ulong index, int sym, bool* pUseFull ) {
    int low,high,tot;
    int largest,escape;
    ContextNode * n;
    SeeState *ss;
    ContextData * cd;

    assert( ! isExcluded( exc, sym ) );

    if (cntx->full.totSymCount == 0) {
        assert( cntx->upex.totSymCount == 0 );
        return FALSE;
    }

    if (*pUseFull && context_chooseFull(cntx,exc,see,index) ) {
        cd = &cntx->full;
    } else {
        cd = &cntx->upex;
    }
    assert( cd->totSymCount > 0 );

    *pUseFull = FALSE; //@@ do this?

    contextData_getExcludedInfo(cd,exc,&tot,&largest,&escape);

    if (tot == 0)  { // no chars unexcluded
        return FALSE;
    }
    low = high = 0;

    for (n = cd->syms;   n;   n = n->next) {

        assert( n->count > 0 );
        
        if (!isExcluded( exc, n->sym ) ) {
            if (n->sym == sym) {
                /* Found it: */
                high = low + n->count;
                assert( high > 0 );
            } else if (high == 0) {
                low += n->count;
            }
            setExcluded(exc,n->sym);
        }
    }

    assert( tot < arith->probMax && high <= tot );

    #ifdef DO_USE_LOE_SEESTATE //{

    ss = cd->loeSeeState;
    #else //}{

    if ( escape > tot ) ss = NULL;
    else                ss = see_getState(see,escape,tot,index,cntx->order,cd->numSyms,cntx);

    #endif //} DO_USE_LOE_SEESTATE 

    if (high) {
        /* Found it: */
        see_encodeEscape(see,arith,ss,escape,tot,FALSE);
        arith_encode(arith,low,high,tot);
        return TRUE;
    } else {
        see_encodeEscape(see,arith,ss,escape,tot,TRUE);
        return FALSE;
    }
}

/* */
bool codeContext_decodeFromContext( Arith* arith, Context* cntx, Exclude* exc, See* see, ulong index, int* psym, bool* pUseFull ) {
    int low,got,tot,escape,largest;
    ContextNode * n;
    SeeState *ss;
    ContextData * cd;

    if (*pUseFull && context_chooseFull(cntx,exc,see,index))   cd = &cntx->full;
    else                                                       cd = &cntx->upex;

    if (cd->totSymCount == 0)    return FALSE;

    *pUseFull = FALSE; //@@

    contextData_getExcludedInfo(cd,exc,&tot,&largest,&escape);

    if (tot == 0) { // no chars unexcluded
        return FALSE;
    }

    #ifdef DO_USE_LOE_SEESTATE //{

    ss = cd->loeSeeState;

    #else //}{

    if (escape > tot)   ss = NULL;
    else                ss = see_getState( see, escape, tot, index, cntx->order, cd->numSyms, cntx );

    #endif //} DO_USE_LOE_SEESTATE 

    if (see_decodeEscape( see, arith, ss, escape, tot ) )	{
        n = cd->syms;
        while (n) {
            setExcluded( exc, n->sym );
            n = n->next;
        }
        return FALSE;
    }

    assert( tot < arith->probMax );

    got = arith_get( arith, tot );
	
    low = 0;

    n = cd->syms;
    while (n) {
	int high;
        assert( got >= low );
        if (!isExcluded( exc, n->sym )) {
            high = low + n->count;
            if (got < high) {
                /* Found it: */
                arith_decode( arith, low, high, tot );
                *psym = n->sym;
                return TRUE;
            }
            low = high;
        }
        n = n->next;
    }

    assert(0); // !! should not get here!
    return FALSE;
}
