#include "inc.h"
#include "exclude.h"

typedef ubyte exclude_t;

#define resetVal ((exclude_t)(~((exclude_t)0)))

struct Exclude {
    uint numChars;
    uint counter;
    uint tablePaddedLen;

    exclude_t* table;
    bool       anySet;
};

bool exclude_isEmpty( Exclude* E ){   return ! E->anySet;   }

static void reset( Exclude* e ) {
    memset( e->table, 0, e->tablePaddedLen );
    e->counter = 1;
    e->anySet = FALSE;
}

Exclude* exclude_create( int numChars ) {
    Exclude* e = new( Exclude );
    if (e == NULL)   return NULL;

    e->tablePaddedLen = sizeof(exclude_t)*numChars;
    e->tablePaddedLen = (e->tablePaddedLen + 31) & ~31;
        
    if (!(e->table = malloc( e->tablePaddedLen ))) {
        destroy( e );
        return NULL; 
    }
        
    e->numChars = numChars;
        
    reset( e );

    return e;
}

void exclude_destroy( Exclude* e ) {
    destroy( e->table );
    destroy( e );
}

void exclude_clear( Exclude* e ) {
    e->counter ++;
    e->anySet = FALSE;
    if (e->counter == resetVal) {
        reset( e );
    }        
}

void exclude_set( Exclude* e, int sym ) {
    e->table[sym] = e->counter;
    e->anySet = TRUE;
}

bool exclude_test( Exclude* e, int sym ) {
    return   e->table[sym] == e->counter;
}
 
