#ifndef LIST_H
#define LIST_H

#include "inc.h"

typedef struct List List;
typedef struct Node Node;
struct Node {
    Node* Next;
    Node* Prev;
}; 

#define znode_initList(list)      do { (list)->Next = (list); (list)->Prev = (list); } while(0)
#define znode_cut(node)           do { (node)->Prev->Next = (node)->Next; (node)->Next->Prev = (node)->Prev; znode_initList(node); } while(0)
#define znode_fix(node)           do { (node)->Prev->Next = (node); (node)->Next->Prev = (node); } while(0)
#define znode_addAfter(node,list) do { (node)->Prev = (list); (node)->Next = (list)->Next; node_fix(node); } while(0)

#define node_initList(list)       znode_initList((Node*)(list))
#define node_cut(node)            znode_cut((Node*)(node))
#define node_fix(node)            znode_fix((Node*)(node))
#define node_addAfter(node,list)  znode_addAfter((Node*)node,(Node*)list)
#define node_next(node)           (void*)(((Node*)node)->Next)

#define node_null(node)           node_initList(node)
#define node_addHead(list,node)   node_addAfter(node,list)

Node* node_cutTail( Node* node );


#endif  /* LIST_H */

