#include "minusone.h"

/*******

 Order (-1) coder

 Totally flat probabilities with exclusions

*********/

void encodeOrderMinusOne( uint sym, uint numChars, Arith* arith, Exclude* exclude ) {

    uint low = 0;;
    uint tot;
    uint i;

    assert( ! isExcluded( exclude, sym ) );

    for (i = 0;   i < sym;   i++) {
        if (!isExcluded( exclude, i ))  ++low;
    }
    tot = low +1;
    for (i = sym +1;   i < numChars;   i++) {
        if (!isExcluded( exclude, i ))   ++tot;
    }

    arith_encode( arith, low, low +1, tot );
}

uint decodeOrderMinusOne( uint numChars, Arith* arith, Exclude* exclude ) {
    uint target, i, sym;

    uint tot = 0;
    for (i = 0;   i < numChars;   i++) {
        if (!isExcluded( exclude, i ))   ++tot;
    }

    target = arith_get( arith, tot );
    arith_decode( arith, target, target +1, tot );

    for (sym = 0;   ;   ++sym, --target) {
        while (isExcluded( exclude, sym ))   ++sym;
        if (!target)   return sym;
    }
}
