#ifndef POOL_H
#define POOL_H

#include "inc.h"

typedef struct Pool Pool;

void* autoPool_getHunk(  Pool** pool, int* numHunks, int hunkSize );
void  autoPool_freeHunk( Pool** pool, int* numHunks, void* hunk   );
void  autoPool_destroy(  Pool** pool, int* numHunks               );

extern Pool* pool_create( long hunkLength, long numHunks, long autoExtendNumItems );
extern void  pool_destroy(  Pool* pool ); /* ok to call this with pool == NULL */
extern void* pool_getHunk(  Pool* pool, bool autoExtendFlag );

#endif /* POOL_H */
